/* ================================================================== */
/* Cookie.c - cookie extraction functions for CGI programs.

   Website  : http://www.txtswap.com/cookie/
   Contact  : phil@txtswap.com
   Revision : v1.1 17/04/2002
 
 Copyright (c) 2002 Philip Rhys Worgan.  All Rights Reserved.
 Redistribution in part or in whole strictly prohibited.
 
 This code is provided as is no support can be guaranteed whatsover,
 however i will try to answer questions when i have time.
 
 =================================================================
 
 Produced on behalf of Txtswap.com - Spread the Word
 
 Txtswap is a Txt based website promotion network, please visit 
 Txtswap.com for more information
 
 ==================================================================

 COPYRIGHT NOTICE:

 Copyright 2002 Philip Rhys Worgan.  All Rights Reserved.

 This program is being distributed as freeware.  It may be used and
 modified free of charge for any use, so long as this copyright notice 
 and the header above remain intact and so long as there is a link made to 
 txtswap.com from somewhere within your site. If you do not wish to make this link 
 please contact me and i will provide information about licensing this product.
 Please also send me an email, and let me know where you are using this script. 
 By using this program you agree to indemnify Philip Rhys Worgan and 
 Txtswap.com from any liability.
 
 Selling the code for this program without prior written consent is
 expressly forbidden.  Obtain permission before redistributing this
 program over the Internet or in any other medium.  In all cases
 copyright and header must remain intact.

 ===================================================================== */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cookie.h"

nvDataStruct *nvTable;

char *getCookies ()
/* returns the contents of cookie*/
{
  char *query = getenv ("HTTP_COOKIE");
  char *temp;
  char *lines;
  char *location = query;
  int i, j, k, l, row;
  int entries=0;
  int flag=0;

  fflush(NULL);
  
  if (query==NULL) return(NULL);
  
/*count number of name value pairs*/      
  while (flag==0)
  {
  flag=1;
  if (location=strchr(location,'='))
     {
     location=(strchr(location,'=')+1);
     entries=entries+1;
     flag=0;
     }
   }
   
   /*dynamically assign enough memory for the number of entries*/
   lines =  (char *) malloc (entries * 4096);
   nvTable = (nvDataStruct *) malloc ((entries+1) * sizeof (nvDataStruct));
   for(i=0; i!=(entries+1); i++)
         {
         nvTable[i].field = (char *) malloc (4096);
         nvTable[i].value = (char *) malloc (4096);
         }
   
   
   /* Last row of table set to NULL to work as a sentinel*/
   for(i=0; i!=(entries+1); i++)
         {
         for(j=0; j<4096; j++)
            {
            nvTable [i].field[j] = '\0';
            nvTable [i].value[j] = '\0';
            }
         }
   
   for(j=0; j<(entries*4096); j++)
            {
            lines[j] = '\0';
            }
            
   /*copy query to array for direct manipulation*/
   strcpy(lines, query);
   strncat(lines,";",1);  /*the last cookie is unterminated normally*/
   
   /*intialized loop variables*/
   i=0;
   j=-1;
   k=0;
   l=0;
   row=0;


  while (lines[i]!='\0')
  {
  /*fprintf(stderr, "in while\n");*/
  if (lines[i]=='=')
     {
     /*extract name*/
     l=0;
     for(k=(j+1); k<i; k++)
         {
         if (lines[k]!=' ') 
            {
            nvTable [row].field[l] = lines[k];
            l++;
            }  
         }
     nvTable [row].field[l] = '\0';         
     /*find end of value*/
     j++;
     while (lines[j]!=';')
         {
         j++;
         }
     /*extract value*/
     l=0;
     for(k=(i+1); k<j; k++)
         {
         nvTable [row].value[l] = lines[k];
         l++;
         }
     nvTable [row].value[l] = '\0';    
     row++;
     }
   i++;
   }
   free (lines);  
 return (query);
}

char *extractCookie (char *request)
/* Extracts the value of a field from a CGI string*/
{
  int i = 0;
  int length;

  /*check there were some cookies*/
  if (nvTable==NULL) return NULL;
  
  /*work out length*/
  length=strlen(request);
  /*search table for field requested*/
  while (nvTable [i].field != NULL)
  {
    if (strncmp (nvTable [i].field, request, length) == 0)
        {
        return (nvTable [i].value);
        }
    i++;
  }
  /* If he got here, "field" does not exist*/
  return (NULL);
}


void freeCookies ()
/* Frees some remaining objects in memory*/
{
  free (nvTable);
}
